package vcf.temp;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "vcf.temp", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "vcf.temp", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ListViewWrapper _listview1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public vcftool _vcftool = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 55;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 58;BA.debugLine="activity.LoadLayout(\"pr.bal\")";
mostCurrent._activity.LoadLayout("pr.bal",mostCurrent.activityBA);
 //BA.debugLineNum = 63;BA.debugLine="VCFtool.loadfilevcf";
mostCurrent._vcftool._loadfilevcf(mostCurrent.activityBA);
 //BA.debugLineNum = 64;BA.debugLine="VISTA";
_vista();
 //BA.debugLineNum = 65;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 71;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 73;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 67;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 69;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
                
		        main._process_globals();
vcftool._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 8;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 45;BA.debugLine="Dim ListView1 As ListView";
mostCurrent._listview1 = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 46;BA.debugLine="Dim EditText1 As EditText";
mostCurrent._edittext1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 53;BA.debugLine="End Sub";
return "";
}
public static String  _listview1_itemclick(int _position,Object _value) throws Exception{
String _tex = "";
int _j = 0;
int _gh = 0;
 //BA.debugLineNum = 82;BA.debugLine="Sub ListView1_ItemClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 83;BA.debugLine="Dim tex As String";
_tex = "";
 //BA.debugLineNum = 84;BA.debugLine="Dim j,gh As Int";
_j = 0;
_gh = 0;
 //BA.debugLineNum = 85;BA.debugLine="gh=position";
_gh = _position;
 //BA.debugLineNum = 86;BA.debugLine="edittext1.Text=\"\"";
mostCurrent._edittext1.setText((Object)(""));
 //BA.debugLineNum = 87;BA.debugLine="tex=gh & CRLF";
_tex = BA.NumberToString(_gh)+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 88;BA.debugLine="tex=VCFtool.contact(position).name & CRLF";
_tex = mostCurrent._vcftool._contact[_position].name+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 89;BA.debugLine="tex=tex &VCFtool.contact(position).first_name &CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].first_name+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 90;BA.debugLine="tex=tex & gh & CRLF";
_tex = _tex+BA.NumberToString(_gh)+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 91;BA.debugLine="If VCFtool.contact(position).addr_home <>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].addr_home).equals("-") == false) { 
 //BA.debugLineNum = 92;BA.debugLine="tex=tex & VCFtool.contact(position).addr_home &CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].addr_home+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 94;BA.debugLine="If VCFtool.contact(position).addr_work<>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].addr_work).equals("-") == false) { 
 //BA.debugLineNum = 95;BA.debugLine="tex=tex & VCFtool.contact(position).addr_work &CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].addr_work+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 97;BA.debugLine="If VCFtool.contact(position).tel_home <>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].tel_home).equals("-") == false) { 
 //BA.debugLineNum = 99;BA.debugLine="tex=tex & VCFtool.contact(position).tel_home&\" home number\" &CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].tel_home+" home number"+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 100;BA.debugLine="tex=tex & VCFtool.telchoice(VCFtool.contact(position).tel_home,2)&\" 1st or 2nd home number\" &CRLF";
_tex = _tex+mostCurrent._vcftool._telchoice(mostCurrent.activityBA,mostCurrent._vcftool._contact[_position].tel_home,(int)(2))+" 1st or 2nd home number"+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 102;BA.debugLine="If VCFtool.contact(position).tel_voice <>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].tel_voice).equals("-") == false) { 
 //BA.debugLineNum = 103;BA.debugLine="tex=tex & VCFtool.contact(position).tel_voice &\" voice numbers\" &CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].tel_voice+" voice numbers"+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 104;BA.debugLine="tex=tex & VCFtool.telchoice(VCFtool.contact(position).tel_voice,2) &\" 1st or 2nd voice number \"&CRLF";
_tex = _tex+mostCurrent._vcftool._telchoice(mostCurrent.activityBA,mostCurrent._vcftool._contact[_position].tel_voice,(int)(2))+" 1st or 2nd voice number "+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 106;BA.debugLine="If VCFtool.contact(position).tel_cell<>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].tel_cell).equals("-") == false) { 
 //BA.debugLineNum = 107;BA.debugLine="tex=tex & VCFtool.contact(position).tel_cell &\" cell number\" &CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].tel_cell+" cell number"+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 108;BA.debugLine="tex=tex & VCFtool.telchoice (VCFtool.contact(position).tel_cell,2) &\" 1st or 2nd cell number\"&CRLF";
_tex = _tex+mostCurrent._vcftool._telchoice(mostCurrent.activityBA,mostCurrent._vcftool._contact[_position].tel_cell,(int)(2))+" 1st or 2nd cell number"+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 110;BA.debugLine="If VCFtool.contact(position).tel_cell_pref <>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].tel_cell_pref).equals("-") == false) { 
 //BA.debugLineNum = 111;BA.debugLine="tex=tex & VCFtool.contact(position).tel_cell_pref &\" cell pref  \"&CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].tel_cell_pref+" cell pref  "+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 113;BA.debugLine="If VCFtool.contact(position).tel_work <>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].tel_work).equals("-") == false) { 
 //BA.debugLineNum = 114;BA.debugLine="tex=tex & VCFtool.contact(position).tel_work &\" work number\" &CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].tel_work+" work number"+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 116;BA.debugLine="If VCFtool.contact(position).tel_work_fax <>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].tel_work_fax).equals("-") == false) { 
 //BA.debugLineNum = 117;BA.debugLine="tex=tex & VCFtool.contact(position).tel_work_fax &\" work fax\"&CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].tel_work_fax+" work fax"+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 119;BA.debugLine="If VCFtool.contact(position).note <>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].note).equals("-") == false) { 
 //BA.debugLineNum = 120;BA.debugLine="tex=tex & VCFtool.contact(position).note &\" note \"&CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].note+" note "+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 122;BA.debugLine="If VCFtool.contact(position).note_enc<>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].note_enc).equals("-") == false) { 
 //BA.debugLineNum = 123;BA.debugLine="tex=tex & VCFtool.contact(position).note_enc &\" note encod \"&CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].note_enc+" note encod "+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 125;BA.debugLine="If VCFtool.contact(position).mail_pref<>\"-\" Then";
if ((mostCurrent._vcftool._contact[_position].mail_pref).equals("-") == false) { 
 //BA.debugLineNum = 126;BA.debugLine="tex=tex & VCFtool.contact(position).mail_pref&\" mail \"&CRLF";
_tex = _tex+mostCurrent._vcftool._contact[_position].mail_pref+" mail "+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 129;BA.debugLine="edittext1.Text=tex";
mostCurrent._edittext1.setText((Object)(_tex));
 //BA.debugLineNum = 131;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 6;BA.debugLine="End Sub";
return "";
}
public static String  _vista() throws Exception{
int _x = 0;
 //BA.debugLineNum = 74;BA.debugLine="Sub VISTA";
 //BA.debugLineNum = 75;BA.debugLine="For x=0 To VCFtool.ncontact +1";
{
final double step16 = 1;
final double limit16 = (int)(mostCurrent._vcftool._ncontact+1);
for (_x = (int)(0); (step16 > 0 && _x <= limit16) || (step16 < 0 && _x >= limit16); _x += step16) {
 //BA.debugLineNum = 77;BA.debugLine="listview1.AddTwoLines(VCFtool.contact(x).name&\" \"&VCFtool.contact(x).first_name,VCFtool.contact(x).tel_cell_pref)";
mostCurrent._listview1.AddTwoLines(mostCurrent._vcftool._contact[_x].name+" "+mostCurrent._vcftool._contact[_x].first_name,mostCurrent._vcftool._contact[_x].tel_cell_pref);
 }
};
 //BA.debugLineNum = 81;BA.debugLine="End Sub";
return "";
}
}
